/* $Id: ggigl_int.h,v 1.1 2000/12/10 11:31:36 marcus Exp $
******************************************************************************

   GGIGL extension internals

   Copyright (C) 2000 Marcus Sundberg	[marcus@ggi-project.org]
  
   Permission is hereby granted, free of charge, to any person obtaining a
   copy of this software and associated documentation files (the "Software"),
   to deal in the Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish, distribute, sublicense,
   and/or sell copies of the Software, and to permit persons to whom the
   Software is furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in
   all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
   THE AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
   IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

******************************************************************************
*/

#ifndef _GGI_GGIGL_INT_H
#define _GGI_GGIGL_INT_H

#include <ggi/internal/internal.h>
#ifdef BUILDING_LIBGGIGL
# include "ggigl.h"
#else
# include <ggi/ggigl.h>
#endif

__BEGIN_DECLS

/* Exported variables */
#ifdef BUILDING_LIBGGIGL
extern ggi_extid    _ggiglID;
#else
IMPORTVAR ggi_extid _ggiglID;
#endif

__END_DECLS

/* Data types for the API functions */
typedef void (ggiglfunc_swapbuffers)(ggi_visual *vis);


struct ggigl_attribs {
	int buffer_size;
	int level;
	int rgba;
	int doublebuffer;
	int stereo;
	int aux_buffers;
	int red_size;
	int green_size;
	int blue_size;
	int alpha_size;
	int depth_size;
	int stencil_size;
	int accum_red_size;
	int accum_green_size;
	int accum_blue_size;
	int accum_alpha_size;
};


typedef struct ggiglpriv {
	ggiglfunc_swapbuffers  *swapbuffers;
	struct ggigl_attribs attribs;
	void *priv;
} ggiglpriv;

/* Used to access the ggiglpriv structure for a particular visual. */
#define GGIGLEXT_PRIV(vis) ((ggiglpriv *)LIBGGI_EXT((vis),_ggiglID))

#endif /* _GGI_GGIGL_INT_H */
